#version 330

uniform sampler2D texUnit;
uniform float threshold = 0.5f;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Set an uniform for threshold.
// 2) Convert the texel to grayscale.
// 3) Threshold the intensity to decide between black and white output.
//----------------------------------------------------------------

void main()
{
	// Convert to greyscale using NTSC weightings
	vec3 NTSCWeights = vec3(0.299f, 0.587f, 0.114f);
	
	ivec2 pos = ivec2(gl_FragCoord);
	vec4 texel = texelFetch(texUnit, pos, 0);
	float gray = dot(texel.rgb, NTSCWeights);

	if(gray > threshold)
		outputF = vec4(vec3(1.f), texel.a);
	else
		outputF = vec4(vec3(0.f), texel.a);
}